
TYPO3.Flow - Bug # 37357

Task # 55953 (New): Repair and streamline ValueObject support

Status: Resolved Priority: Should have
Author: Adrian Föder Category: Persistence
Created: 2012-05-21 Assigned To: Adrian Föder
Updated: 2015-02-16 Due date:
PHP Version:
Has patch: Yes
Complexity: easy
Affected Flow version: (any)
Subject: more suitable ValueObject hash creation for DateTime cases
Description

currently, DateTime objects are only represented by their ("unix-") Timestamp, which may result in unpredictable behavior when
server time (zone) or Daylight Saving Time changes.
An RFC850 formatted date seems to be more appropriate, it says e.g. Monday, 15-Aug-05 15:52:01 UTC or Monday, 21-May-12
14:19:41 CEST (note the s in CEST that indicates summer time).

Otherwise, both, for example, British Summer Time (+01:00) and Central European Time (non-summer) would be +01:00, but
representing very different actual Dates.

Associated revisions
Revision 2d6a0dfd - 2015-02-15 18:26 - Philipp Maier

[!!!][BUGFIX] Generate Value Object hash from property values

This changes the Value Objects' hash generation algorithm to
use the actual properties of the Value Object, not only the
constructor arguments which lead to duplicate hashes in cases
where arguments were empty.

Furthermore the initial approach disregarded everything that
can be done within the constructor (such as trimming, calculations,
etc.).

This patch delays the generation of the value hash to just after
instantiation, where the Value Object is completely initialized.
The final object properties names and values are then hashed.

Additionally, the handling of DateTime objects has been improved.
The generated ValueHash now also includes information about the
timezone.

This might be breaking in the unlikely case where the initial
hash calculation leads to the same hash as the new calculation,
for different VOs. Besides, it might lead to duplicate VOs in the
database because the "same" VO can become a new hash due to the
changed hashing algorithm.

Change-Id: Iaf4d2a28bcd8fc5bf2c749f8021171456616e45c

2015-08-03 1/4



Fixes: #51236
Fixes: #37357
Releases: master

History
#1 - 2012-05-21 14:31 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11368

#2 - 2012-05-21 16:40 - Karsten Dambekalns
- Target version changed from 1.1 beta 2 to 2.0 beta 1

#3 - 2012-07-31 09:58 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11368

#4 - 2012-12-10 13:10 - Karsten Dambekalns
- Target version changed from 2.0 beta 1 to 2.1
- Affected Flow version changed from Git master to (any)

#5 - 2012-12-18 18:10 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/11368

#6 - 2012-12-18 18:14 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/11368

#7 - 2013-05-21 13:28 - Robert Lemke
- Target version deleted (2.1)

#8 - 2013-08-22 15:24 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/23241

#9 - 2013-08-22 15:28 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/23241
#10 - 2013-09-25 23:54 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/23241

#11 - 2013-10-14 23:09 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/23241

#12 - 2014-02-13 11:16 - Adrian Föder
- Parent task set to #55953

#13 - 2014-02-24 14:02 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/23241

#14 - 2015-01-09 18:51 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/23241

#15 - 2015-01-09 18:54 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/23241

#16 - 2015-02-14 11:54 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/23241

#17 - 2015-02-15 11:57 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/23241

#18 - 2015-02-15 17:40 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/23241

#19 - 2015-02-15 18:26 - Gerrit Code Review
Patch set 13 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/23241

#20 - 2015-02-16 00:30 - Philipp Maier
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:2d6a0dfdadd82877c210abead884cec55805ce16.
